﻿@using System.Web.Mvc.Html
@using Jb.Framework.Common.Forms;
@using Jb.Framework.Common.Forms.Validation
@model Jb.Framework.Common.Forms.JbTextArea

@{
    var width = "element_width-full";
    switch (Model.Width)
    {
        case ElementWidth.Half:
            {
                width = "element_width-half";
            }
            break;
        case ElementWidth.Full:
            {
                width = "element_width-full";
            }
            break;
    }

    var textBoxHtmlAttr = new Dictionary<string, object>();
    InputHelper.InputAccessible(Model, (VisibilityMode)ViewBag.VisibleMode, ref textBoxHtmlAttr);
    textBoxHtmlAttr.Add("class", "form-control"); // @Salman please add your style here
    textBoxHtmlAttr.Add("Rows", 2);
    textBoxHtmlAttr.Add("cols", 20);
    textBoxHtmlAttr.Add("style", "resize: vertical;");

    textBoxHtmlAttr.Add("placeholder", Model.PlaceHolder);
    textBoxHtmlAttr.Add("data-clientid", Model.Name);

    if (Model.IsConditional)
    {
        textBoxHtmlAttr.Add("data-conditional", true);
        textBoxHtmlAttr.Add("data-RelatedElementId", Model.RelatedElementId);
        textBoxHtmlAttr.Add("data-RelatedElementValue", Model.RelatedElementValue);
    }

    if (Model.Validations.Any(x => x.Type != ElementValidationType.None))
    {
        textBoxHtmlAttr.Add("data-val", "true");
    }
    if (Model.Validations.Any(x => x.Type == ElementValidationType.Required))
    {
        textBoxHtmlAttr.Add("data-val-Required", Model.Validations.First(x => x.Type == ElementValidationType.Required).Message);
    }
}

@Html.Hidden("ModelType", Model.GetType())

@for (var i = 0; i < Model.Validations.Count; i++)
{
    var hiddnModelBindername = "Validations[" + i + "].QVModelType";
    @Html.Hidden(hiddnModelBindername, Model.Validations[i].GetType())

    @Html.HiddenFor(x => x.Validations[i].IsChecked)
    @Html.HiddenFor(x => x.Validations[i].Type)
    @Html.HiddenFor(x => x.Validations[i].Message)

    if (Model.Validations[i] is ElementMaxLengthValidation)
    {

        var validations = Model.Validations[i] as ElementMaxLengthValidation;
        var hiddenMinModelName = "Validations[" + i + "].Length";
        @Html.Hidden(hiddenMinModelName, validations.Length)
    }

}

@Html.GenerateHiddenFields(Model)

@foreach (var accRole in Model.AccessRole)
{
    @Html.HiddenFor(modelItem => accRole)
}

@if (Model.CurrentMode == AccessMode.Print) { 
<div class="form-group JbFormControll JbTextArea @width" style="display: @(Model.VisibleMode != VisibilityMode.Both && Model.VisibleMode != (VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">
    @Html.LabelFor(m => m.Value, Model.Title, new { @class = (Model.Validations.Any(t => t.Type == ElementValidationType.Required) || Model.IsRequired) ? "req" : "" })
    <p> @Model.Value </p>
</div>
}
else
{
    <div class="form-group JbFormControll JbTextArea @width" style="display: @(Model.VisibleMode != VisibilityMode.Both && Model.VisibleMode != (VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">
        @Html.LabelFor(m => m.Value, Model.Title, new { @class = (Model.Validations.Any(t => t.Type == ElementValidationType.Required) || Model.IsRequired) ? "req" : "" })
        @if (!string.IsNullOrEmpty(Model.HelpText))
        {
            <a href="#" class="help" role="button" data-toggle="popover" data-trigger="focus" data-content="@Model.HelpText"></a>
        }
        @Html.TextAreaFor(x => x.Value, htmlAttributes: textBoxHtmlAttr)
        @Html.ValidationMessageFor(model => model.Value)
    </div>
}